;==============================================================================
    include \masm32\include\masm32rt.inc
;==============================================================================

_TEXTMETRICA STRUCT DWORD
  tmHeight              DWORD      ?
  tmAscent              DWORD      ?
  tmDescent             DWORD      ?
  tmInternalLeading     DWORD      ?
  tmExternalLeading     DWORD      ?
  tmAveCharWidth        DWORD      ?
  tmMaxCharWidth        DWORD      ?
  tmWeight              DWORD      ?
  tmOverhang            DWORD      ?
  tmDigitizedAspectX    DWORD      ?
  tmDigitizedAspectY    DWORD      ?
  tmFirstChar           BYTE      ?
  tmLastChar            BYTE      ?
  tmDefaultChar         BYTE      ?
  tmBreakChar           BYTE      ?
  tmItalic              BYTE      ?
  tmUnderlined          BYTE      ?
  tmStruckOut           BYTE      ?
  tmPitchAndFamily      BYTE      ?
  tmCharSet             BYTE      ?
_TEXTMETRICA ENDS

_OUTLINETEXTMETRICA STRUCT DWORD
  otmSize                   DWORD      ?
  otmTextMetrics            _TEXTMETRICA <>
  otmFiller                 BYTE       ?
  otmPanoseNumber           PANOSE     <>
  otmfsSelection            DWORD      ?
  otmfsType                 DWORD      ?
  otmsCharSlopeRise         DWORD      ?
  otmsCharSlopeRun          DWORD      ?
  otmItalicAngle            DWORD      ?
  otmEMSquare               DWORD      ?
  otmAscent                 DWORD      ?
  otmDescent                DWORD      ?
  otmLineGap                DWORD      ?
  otmsCapEmHeight           DWORD      ?
  otmsXHeight               DWORD      ?
  otmrcFontBox              RECT       <>
  otmMacAscent              DWORD      ?
  otmMacDescent             DWORD      ?
  otmMacLineGap             DWORD      ?
  otmusMinimumPPEM          DWORD      ?
  otmptSubscriptSize        POINT      <>
  otmptSubscriptOffset      POINT      <>
  otmptSuperscriptSize      POINT      <>
  otmptSuperscriptOffset    POINT      <>
  otmsStrikeoutSize         DWORD      ?
  otmsStrikeoutPosition     DWORD      ?
  otmsUnderscoreSize        DWORD      ?
  otmsUnderscorePosition    DWORD      ?
  otmpFamilyName            DWORD      ?
  otmpFaceName              DWORD      ?
  otmpStyleName             DWORD      ?
  otmpFullName              DWORD      ?
_OUTLINETEXTMETRICA ENDS

;==============================================================================

printf MACRO format:REQ, args:VARARG
    IFNB <args>
        invoke crt_printf, cfm$(format), args
    ELSE
        invoke crt_printf, cfm$(format)
    ENDIF
    EXITM <>
ENDM

;==============================================================================
    .data
        tm _TEXTMETRICA         <>
        otm _OUTLINETEXTMETRICA <>
    .code
;==============================================================================
start:
;==============================================================================
    printf( "_TEXTMETRICA:\n" )
    printf( "%d\n", OFFSET tm.tmHeight - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmAscent - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmDescent - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmInternalLeading - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmExternalLeading - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmAveCharWidth - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmMaxCharWidth - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmWeight - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmOverhang - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmDigitizedAspectX - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmDigitizedAspectY - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmFirstChar - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmLastChar - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmDefaultChar - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmBreakChar - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmItalic - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmUnderlined - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmStruckOut - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmPitchAndFamily - OFFSET tm.tmHeight )
    printf( "%d\n", OFFSET tm.tmCharSet - OFFSET tm.tmHeight )

    printf( "\n_OUTLINETEXTMETRICA:\n" )

    printf( "%d\n", OFFSET otm.otmSize - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmTextMetrics - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmFiller - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmPanoseNumber - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmfsSelection - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmfsType - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmsCharSlopeRise - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmsCharSlopeRun - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmItalicAngle - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmEMSquare - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmAscent - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmDescent - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmLineGap - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmsCapEmHeight - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmsXHeight - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmrcFontBox - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmMacAscent - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmMacDescent - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmMacLineGap - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmusMinimumPPEM - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmptSubscriptSize - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmptSubscriptOffset - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmptSuperscriptSize - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmptSuperscriptOffset - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmsStrikeoutSize - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmsStrikeoutPosition - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmsUnderscoreSize - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmsUnderscorePosition - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmpFamilyName - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmpFaceName - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmpStyleName - OFFSET otm.otmSize )
    printf( "%d\n", OFFSET otm.otmpFullName - OFFSET otm.otmSize )

    printf( "\nSIZEOF OUTLINETEXTMETRICA:%d\n", SIZEOF OUTLINETEXTMETRICA )
    printf( "SIZEOF _OUTLINETEXTMETRICA:%d\n", SIZEOF _OUTLINETEXTMETRICA )
    printf( "SIZEOF TEXTMETRICA:%d\n", SIZEOF TEXTMETRICA )
    printf( "SIZEOF _TEXTMETRICA:%d\n\n", SIZEOF _TEXTMETRICA )

    inkey "Press any key to exit..."
    exit
;==============================================================================

end start
